
#include <afx.h>
#include <afxole.h>

#include <dbdao.h>
#include <dbdaoerr.h>

#pragma comment(lib, "dbdao3.lib")

void main()
{
	printf("HTTP/1.0 200 OK\n");
	printf("Content-type: text/html\n\n");

	AfxOleInit();

	printf("<HTML>");
	printf("<HEAD><TITLE>DUMPSOME Sample</TITLE></HEAD>\n");
	printf("<BODY>");

	CdbDBEngine engine;
	CdbDatabase database;
	CdbRecordset recset;
	try
	{
		// this sample is hardcoded to use the EMPLOYEE.MDB database
		// from the DAO SDK.  the database must be in the same directory
		// as the excutable file unless you change the parameter to OpenDatabase()

		database = engine.OpenDatabase("employee.mdb");
		recset = database.OpenRecordset(_T("Employees"), dbOpenSnapshot);

		// get the first three rows only
		COleVariant vArray;
		const int nRowsRequested = 3;
		vArray = recset.GetRows(nRowsRequested);

		// Find out how many records we recieved
		LONG lMaxRows;
		LONG lIndexes[2];
		SafeArrayGetUBound(vArray.parray, 1, &lMaxRows);
		lMaxRows = min(nRowsRequested, lMaxRows);

		// react to what we got
		if (lMaxRows == 0)
			printf("<b>No rows retrieved!</b>");
		else
		{
			printf("<TABLE BORDER=1><TR><TD>EmployeeID</TD><TD>First Name</TD>\n");
			printf("<TD>Last Name</TD><TD>Title</TD></TR>\n");

			for (lIndexes[1] = 0; lIndexes[1] < lMaxRows; lIndexes[1]++)
			{
				// get the first four columns, which we know are:
				//		employee id (integer)
				//		last name (string)
				//		first name (string)
				//		title (string)

				// if you use this sample against a different database, you'll 
				// need to adjust the counts here

				printf("<TR>");
				for (lIndexes[0] = 0; lIndexes[0] < 4; lIndexes[0]++)
				{
					COleVariant vField;
					printf("<TD>");

					if (FAILED(SafeArrayGetElement(vArray.parray, lIndexes, &vField)))
						printf("Retrieve Failed!\n");
					else
					{
						// print field
						// in real life, you might check vField.vt
						if (lIndexes[0] != 0)
							printf("%s\t", (LPCTSTR) vField.bstrVal);
						else
							printf("%d\t", vField.iVal);
					}
					printf("</TD>");
				}
				printf("</TR>\n");
			}
		}
	}
	catch (CdbException e)
	{
		CdbLastOLEError exError;
		TCHAR szBuf[256];

		// in real life, you'd not pop-up
		// a message box for error  situations

		wsprintf(szBuf, _T("Error 0x%lx : %s\n"), e.m_hr,
			(LPCTSTR) exError.GetDescription());
		AfxMessageBox(szBuf);
	}

	printf("</BODY></HTML>");
}
